part of tecfy_corev2_client_package;

class PropertyDynamicProperties extends Property {
  late String propertyField;
  bool? isRootProp;

  PropertyDynamicProperties({
    required String dbName,
    required String nameAr,
    required String nameEn,
    required this.propertyField,
    this.isRootProp,
    bool isRequired = false,
    width,
    size,
  }) : super(
            propertyType: PropertyTypes.DynamicProperties,
            dbName: dbName,
            nameAr: nameAr,
            nameEn: nameEn,
            isRequired: isRequired,
            valueType: ValueTypes.Text,
            width: width,
            size: size);

  PropertyDynamicProperties.fromMap(Map<String, dynamic> row)
      : super.fromMap(row) {
    propertyField = row['propertiesFiled'];
    isRootProp = row['isRootProp'];
  }

  @override
  OperationResult isValid(data) {
    if (!super.isValid(data).success) return super.isValid(data);

    return OperationResult(success: true);
  }

  /// get the value and bind tp display widget
  Widget getDisplayWidget(Map<String, dynamic> data, {TextStyle? textStyle}) {
    return Text('Dynamic Properties');
  }

  /// get the value in text
  String getDisplayText(Map<String, dynamic> data) {
    return 'Dynamic Properties';
  }

  Future<bool> getDefaultValue(Map<String, dynamic> data) async {
    if (MapService.getValue(data, dbName) != null) return false;

    return false;
  }
}
