part of tecfy_corev2_client_package;

class PropertyLocation extends Property {
  /// <summary>
  /// Square, Rectangle, Circle, Other
  /// </summary>
  late String shapeType;

  PropertyLocation.fromMap(Map<String, dynamic> row) : super.fromMap(row) {
    shapeType = row['shapeType'] ?? '';
  }

  @override
  OperationResult isValid(data) {
    if (!super.isValid(data).success) return super.isValid(data);

    return OperationResult(success: true);
  }

  /// get the value and bind tp display widget
  Widget getDisplayWidget(Map<String, dynamic> data, {TextStyle? textStyle}) {
    return Text(getDisplayText(data), style: textStyle);
  }

  /// get the value in text
  String getDisplayText(Map<String, dynamic> data) {
    // if (dbName.contains('.')) {
    //   if (MapService.getValue(data, dbName) != null) {
    //     print('##@>  ${MapService.getValue(data, dbName)}');
    var value = MapService.getValue(data, dbName);
    if (value is String) {
      return value;
    }
    if (value is Map) {
      String str = '';
      value.forEach((key, value) {
        str += '$key: $value, ';
      });
      return str;
    }
    return MapService.getValue(data, dbName)?.toString() ?? '';
    // }
    // }
    // return '';
  }

  Future<bool> getDefaultValue(Map<String, dynamic> data) async {
    if (MapService.getValue(data, dbName) != null) return false;

    return false;
  }
}
