import 'package:flutter/material.dart';
import 'package:google_maps_flutter/google_maps_flutter.dart';
import 'package:tecfy_corev2_package/tecfy_core_client_package.dart';

class LocationSelectPage extends StatefulWidget {
  final LatLng location;
  LocationSelectPage(this.location);
  @override
  _LocationSelectPageState createState() => _LocationSelectPageState();
}

class _LocationSelectPageState extends State<LocationSelectPage> {
  // String _mapStyle;
  LatLng? _point;
  GlobalKey _key = GlobalKey();
  // GoogleMapController _controller;
  @override
  initState() {
    _point = widget.location;
    super.initState();
  }

  @override
  Widget build(BuildContext context) {
    return Container(
        width: MediaQuery.of(context).size.width,
        height: MediaQuery.of(context).size.height,
        child: Column(
          children: [
            Expanded(
                flex: 10,
                child: GoogleMap(
                  zoomControlsEnabled: true,
                  // onMapCreated: (c) => _controller = c,
                  key: _key,
                  initialCameraPosition: CameraPosition(
                      zoom: 10,
                      target: _point == null
                          ? LatLng(31.274750, 32.301204)
                          : _point!),
                  // initialPosition: point ?? GeoCoord(0, 0),
                  mapType: MapType.hybrid,
                  indoorViewEnabled: true,
                  myLocationButtonEnabled: true,
                  myLocationEnabled: true,
                  markers: _point == null
                      ? {}
                      : {
                          Marker(
                              position: _point!,
                              markerId: MarkerId("marker2"),
                              icon: BitmapDescriptor.defaultMarker)
                        },

                  onTap: (coord) {
                    setState(() {
                      _point = coord;
                    });
                    // _controller.getLatLng(screenCoordinate)
                    // GoogleMap.of(_key).clearMarkers();
                    // GoogleMap.of(_key).addMarker(Marker(point));
                  },
                )),
            Expanded(
                flex: 1,
                child: Container(
                    color: Colors.white,
                    child: Row(children: [
                      TextButton(
                          child: TecfyText('OK'),
                          onPressed: () {
                            Navigator.pop(context, _point);
                          }),
                      TextButton(
                          child: TecfyText('Cancel'),
                          onPressed: () {
                            Navigator.pop(context);
                          }),
                    ])))
          ],
        ));
  }
}
