part of tecfy_corev2_client_package;

class DashboardPage extends StatefulWidget {
  @override
  _DashboardPageState createState() => _DashboardPageState();
}

class _DashboardPageState
    extends TecfyStateView<DashboardPage, DashboardController> {
  final ScrollController _scrollController = ScrollController();
  @override
  void initState() {
    super.initState();
    _controller = DashboardController(this);
  }

  @override
  void dispose() {
    _scrollController.dispose();
    super.dispose();
  }

  @override
  Widget build(BuildContext context) {
    return BasePage(context, 'Main Page', '',
        isMobile: LayoutService.isMobile(context),
        isHome: true,
        // appBarActions: kIsWeb || Platform.isWindows
        //     ? [
        //         IconButton(
        //             icon: Icon(Icons.refresh),
        //             onPressed: _controller.refreshData)
        //       ]
        //     : null,
        child: DashboardController.dashboards == null
            ? Center(child: AppNavigator.getLoadingWidget(100))
            : DashboardController.dashboards?.length == 0
                ? Container()
                : DashboardController.dashboards?.length == 1
                    ? _getWidgetData()
                    : Column(
                        children: [
                          // _getFilterWidget(),
                          Expanded(child: _getWidgetData())
                        ],
                      ));
  }

  Widget _getFilterWidget() {
    return Container(
      constraints: BoxConstraints(maxWidth: ThemeService.containerWidth),
      padding: EdgeInsets.only(top: 10),
      child: Align(
          alignment: Alignment.centerLeft,
          child: SingleChildScrollView(
            scrollDirection: Axis.horizontal,
            child: Row(
              crossAxisAlignment: CrossAxisAlignment.end,
              children: [
                SizedBox(width: 10),
                // Container(
                //     constraints: BoxConstraints(maxWidth: 200),
                //     child: DropdownButtonHideUnderline(
                //       child: DropdownButtonFormField(
                //         //decoration: InputDecoration(labelTecfyText: 'Das
                //         hboa
                //         rd'),
                //         value: _controller.activeDashboard?.id,
                //         onChanged: (v) {
                //           _controller.activeDashboard =
                //               _controller.dashboards.firstWhere((e) => e.id == v);
                //           setState(() {});
                //         },
                //         items: _controller.dashboards
                //             .map<DropdownMenuItem>((d) => DropdownMenuItem(
                //                   child: TecfyText(d.name),
                //                   value: d.id,
                //                 ))
                //             .toList(),
                //       ),
                //     )),

                MaterialButton(
                    child: TecfyText(trans('Today')),
                    color: _controller.filterDate == 'Today'
                        ? ThemeService.secondryColor
                        : ThemeService.mainColor,
                    shape: RoundedRectangleBorder(
                        borderRadius: BorderRadius.circular(0)),
                    elevation: 0,
                    onPressed: () => _controller.filterDateChanged('Today')),
                VerticalDivider(
                    color: Colors.white,
                    thickness: 0.1,
                    width: 0.1,
                    endIndent: 0,
                    indent: 0),
                MaterialButton(
                    child: TecfyText(trans('Week')),
                    elevation: 0,
                    shape: RoundedRectangleBorder(
                        borderRadius: BorderRadius.circular(0)),
                    color: _controller.filterDate == 'Week'
                        ? ThemeService.secondryColor
                        : ThemeService.mainColor,
                    onPressed: () => _controller.filterDateChanged('Week')),
                VerticalDivider(
                    color: Colors.white,
                    thickness: 0.1,
                    width: 0.1,
                    endIndent: 0,
                    indent: 0),
                MaterialButton(
                    child: TecfyText(trans('Month')),
                    elevation: 0,
                    shape: RoundedRectangleBorder(
                        borderRadius: BorderRadius.circular(0)),
                    color: _controller.filterDate == 'Month'
                        ? ThemeService.secondryColor
                        : ThemeService.mainColor,
                    onPressed: () => _controller.filterDateChanged('Month')),
                VerticalDivider(
                    color: Colors.white,
                    thickness: 0.1,
                    width: 0.1,
                    endIndent: 0,
                    indent: 0),
                MaterialButton(
                    child: TecfyText(trans('Year')),
                    color: _controller.filterDate == 'Year'
                        ? ThemeService.secondryColor
                        : ThemeService.mainColor,
                    shape: RoundedRectangleBorder(
                        borderRadius: BorderRadius.circular(0)),
                    elevation: 0,
                    onPressed: () => _controller.filterDateChanged('Year')),

                SizedBox(width: 10),
              ],
            ),
          )),
    );
  }

  Widget _getWidgetData() {
    return Container(
      constraints: BoxConstraints(maxWidth: ThemeService.containerWidth),
      padding: EdgeInsets.only(top: 20),
      child: AnimationLimiter(
        child: SmartRefresher(
          enablePullDown: true,
          enablePullUp: false,
          controller: _controller.refreshController,
          header: WaterDropHeader(complete: Icon(Icons.done)),
          onRefresh: _controller.refreshData,
          child: Scrollbar(
            thumbVisibility: true,
            interactive: true,
            controller: _scrollController,
            child: ListView(
              // shrinkWrap: true,
              controller: _scrollController,
              cacheExtent: getAllHeightOfTheDashboardToSolveScrollBarIssue(
                  _controller.activeDashboard?.items ?? []),
              children: [
                // Row(children: [
                //   Container(
                //       child: Row(
                //     children: [
                //       TecfyTextButton(child: TecfyText('Today'), onPressed: ()
                //       {}),
                //       VerticalDivider(color: Colors.black26, thickness: 1),
                //       TecfyTextButton(child: TecfyText('Week'), onPressed: ()
                //       {}),
                //       VerticalDivider(),
                //       TecfyTextButton(child: TecfyText('Month'), onPressed: ()
                //       {}),
                //       VerticalDivider(),
                //       TecfyTextButton(child: TecfyText('Year'), onPressed: ()
                //       {}),
                //     ],
                //   ))
                // ]),
                //Url Components
                _getWrap(_controller.activeDashboard?.items
                        .where((e) => e.type == "Url")
                        .toList() ??
                    []),
                _getWrap(_controller.activeDashboard?.items
                        .where((e) => e.type == "Statistic")
                        .toList() ??
                    []),
                _getWrap(_controller.activeDashboard?.items
                        .where((e) => e.type == "Chart")
                        .toList() ??
                    []),
              ],
            ),
          ),
        ),
      ),
    );
  }

  double getWidthEx({required DashboardUrl item}) {
    if (item.width == null || !((item.width ?? 0) > 0)) {
      if (item.height == null) {
        return (ThemeService.containerWidth / 12) * (item.size ?? 1);
      } else {
        return item.height as double;
      }
    }
    return item.width as double;
  }

  double getHeightEx({required DashboardUrl item}) {
    if (item.height == null || !((item.height ?? 0) > 0)) {
      if (item.width == null) {
        return (ThemeService.containerWidth / 12) * (item.size ?? 1);
      } else {
        return item.width as double;
      }
    }
    return item.height?.toDouble() ?? 0.0;
  }

  double getDashboardComponentHeight(String? type, DashboardItemBase item) {
    switch (type) {
      case "Url":
        return getHeightEx(item: item as DashboardUrl);
      default:
        return (ThemeService.containerWidth / 12) * (item.size ?? 1);
    }
  }

  double getAllHeightOfTheDashboardToSolveScrollBarIssue(
      List<DashboardItemBase> items) {
    double allHeight = 0.0;
    for (var item in items) {
      allHeight = allHeight + getDashboardComponentHeight(item.type, item);
    }
    return allHeight;
  }

  Wrap _getWrap(List<DashboardItemBase> items) {
    return Wrap(
      alignment: WrapAlignment.center,
      runAlignment: WrapAlignment.center,
      crossAxisAlignment: WrapCrossAlignment.start,
      children: List.generate(
          items.length,
          (index) => AnimationConfiguration.staggeredList(
                position: index,
                duration: const Duration(milliseconds: 375),
                child: SlideAnimation(
                  verticalOffset: 100.0,
                  horizontalOffset: 100,
                  child: FadeInAnimation(
                      child: getDashboardComponent(
                          items[index].type, items[index], index)),
                ),
              )),
    );
  }

  Widget getDashboardComponent(
      String? type, DashboardItemBase item, int index) {
    switch (type) {
      case "Statistic":
        return DashboardStatisticsComponenet(item);
      case "Chart":
        return DashboardChartComponenet(item as DashboardChart);
      case "Url":
        return DashboardUrlComponenet(item as DashboardUrl);
      default:
        return TecfyText(
            _controller.activeDashboard?.items[index].displayName ?? '');
    }
  }
}
